const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const reviews = sequelize.define(
    'reviews',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

rating: {
        type: DataTypes.INTEGER,
      
      

      },

comment: {
        type: DataTypes.TEXT,
      
      

      },

moderation_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"approved",


"rejected"

        ],

      },

visited_at: {
        type: DataTypes.DATE,
      
      

      },

is_anonymous: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  reviews.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity















//end loop



    db.reviews.belongsTo(db.places, {
      as: 'place',
      foreignKey: {
        name: 'placeId',
      },
      constraints: false,
    });

    db.reviews.belongsTo(db.users, {
      as: 'author',
      foreignKey: {
        name: 'authorId',
      },
      constraints: false,
    });



    db.reviews.hasMany(db.file, {
      as: 'photos',
      foreignKey: 'belongsToId',
      constraints: false,
      scope: {
        belongsTo: db.reviews.getTableName(),
        belongsToColumn: 'photos',
      },
    });


    db.reviews.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.reviews.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return reviews;
};


